Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.jdo.annotations
Annotation Type Key

    @Target(value={FIELD,METHOD})
    @Retention(value=RUNTIME)
    public @interface Key

Annotation for the key of a map relation. Corresponds to the xml element "key".

Since:
  2.1
Version:
  2.1

Optional Element Summary
`java.lang.String` | `column` Name of the column to store the key in.
`Column[]` | `columns` The column(s) for the key
`ForeignKeyAction` | `deleteAction` Delete action to apply to the foreign key for the key.
`java.lang.String` | `dependent` Whether the key is dependent on the owner (and will be deleted when the owner is deleted).
`java.lang.String` | `embedded` Whether this key is embedded.
`Embedded[]` | `embeddedMapping` The embedded mapping for the key.
`Extension[]` | `extensions` Vendor extensions.
`java.lang.String` | `foreignKey` Name for a generated foreign key constraint.
`java.lang.String` | `generateForeignKey` Generate or assume a foreign key constraint exists on the column or columns associated with this join.
`java.lang.String` | `index` The name of the index to generate.
`java.lang.String` | `indexed` Whether the value column(s) should be indexed.
`java.lang.String` | `mappedBy` Name of a member in the value class where this key is stored.
`java.lang.String` | `serialized` Whether the key is to be stored serialized (into a single column of a join table).
`java.lang.String` | `table` Name of the table for the key.
`java.lang.Class[]` | `types` Types of the keys.
`java.lang.String` | `unique` Whether the element column(s) contents should be considered unique
`java.lang.String` | `uniqueKey` The name of the unique key constraint to generate.
`ForeignKeyAction` | `updateAction` Update action to apply to the foreign key for the key.

### types

    public abstract java.lang.Class[] types

  Types of the keys. This can be determined if using JDK1.5 generics but is required otherwise. Multiple types can be specified if the implementation supports multiple types.

  Returns:
    the types of keys
  Default:
    {}

### serialized

    public abstract java.lang.String serialized

  Whether the key is to be stored serialized (into a single column of a join table).

  Returns:
    whether the key is to be stored serialized
  Default:
    ""

### embedded

    public abstract java.lang.String embedded

  Whether this key is embedded.

  Returns:
    whether this key is embedded
  Default:
    ""

### embeddedMapping

    public abstract Embedded[] embeddedMapping

  The embedded mapping for the key.

  Returns:
    the embedded mapping for the key
  Default:
    {}

### dependent

    public abstract java.lang.String dependent

  Whether the key is dependent on the owner (and will be deleted when the owner is deleted).

  Returns:
    whether the key is dependent on the owner
  Default:
    ""

### table

    public abstract java.lang.String table

  Name of the table for the key.

  Returns:
    name of the table for the key
  Default:
    ""

### column

    public abstract java.lang.String column

  Name of the column to store the key in.

  Returns:
    name of the column to store the key in
  Default:
    ""

### deleteAction

    public abstract ForeignKeyAction deleteAction

  Delete action to apply to the foreign key for the key.

  Returns:
    delete action to apply to the foreign key for the key
  Default:
    javax.jdo.annotations.ForeignKeyAction.UNSPECIFIED

### updateAction

    public abstract ForeignKeyAction updateAction

  Update action to apply to the foreign key for the key.

  Returns:
    update action to apply to the foreign key for the key
  Default:
    javax.jdo.annotations.ForeignKeyAction.UNSPECIFIED

### indexed

    public abstract java.lang.String indexed

  Whether the value column(s) should be indexed.

  Returns:
    whether the value column(s) should be indexed.
  Default:
    ""

### index

    public abstract java.lang.String index

  The name of the index to generate.

  Returns:
    the name of the index
  Default:
    ""

### unique

    public abstract java.lang.String unique

  Whether the element column(s) contents should be considered unique

  Returns:
    whether the element column(s) contents should be considered unique
  Default:
    ""

### uniqueKey

    public abstract java.lang.String uniqueKey

  The name of the unique key constraint to generate.

  Returns:
    the name of the unique key constraint
  Default:
    ""

### mappedBy

    public abstract java.lang.String mappedBy

  Name of a member in the value class where this key is stored.

  Returns:
    the name of a member in the value class where this key is stored
  Default:
    ""

### columns

    public abstract Column[] columns

  The column(s) for the key

  Returns:
    the column(s) for the key
  Default:
    {}

### generateForeignKey

    public abstract java.lang.String generateForeignKey

  Generate or assume a foreign key constraint exists on the column or columns associated with this join. Specify "true" or "false".

  Returns:
    whether to generate or assume a foreign key constraint
  Default:
    ""

### foreignKey

    public abstract java.lang.String foreignKey

  Name for a generated foreign key constraint.

  Returns:
    the name of the generated foreign key constraint
  Default:
    ""

### extensions

    public abstract Extension[] extensions

  Vendor extensions.

  Returns:
    the vendor extensions
  Default:
    {}

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT